"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Provider = exports.Store = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

exports.connect = connect;
exports.makeAction = makeAction;

var _react = require("react");

var React = _interopRequireWildcard(_react);

var _propTypes = require("prop-types");

var PropTypes = _interopRequireWildcard(_propTypes);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Store = exports.Store = function () {
  function Store(initialState) {
    var _this = this;

    _classCallCheck(this, Store);

    this.subscriptions = [];

    this.dispatch = function (fn) {
      return fn(_this);
    };

    this.state = new Proxy(initialState, {
      set: function set(target, property, value) {
        target[property] = value;
        if (!_this.subscriptions) {
          return true;
        }
        var _iteratorNormalCompletion = true;
        var _didIteratorError = false;
        var _iteratorError = undefined;

        try {
          for (var _iterator = _this.subscriptions[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
            var onChange = _step.value;

            if (onChange) {
              onChange(_this.state);
            }
          }
        } catch (err) {
          _didIteratorError = true;
          _iteratorError = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion && _iterator.return) {
              _iterator.return();
            }
          } finally {
            if (_didIteratorError) {
              throw _iteratorError;
            }
          }
        }

        return true;
      }
    });
  }

  _createClass(Store, [{
    key: "subscribe",
    value: function subscribe(onChange) {
      var id = this.subscriptions.length;
      this.subscriptions.push(onChange);
      return id;
    }
  }, {
    key: "unsubscribe",
    value: function unsubscribe(subscriptionId) {
      delete this.subscriptions[subscriptionId];
    }
  }]);

  return Store;
}();

function connect(component, mapStateToProps, defaultProps) {
  var _class, _temp;

  return _temp = _class = function (_React$Component) {
    _inherits(_class, _React$Component);

    function _class(props, context) {
      _classCallCheck(this, _class);

      var _this2 = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, props, context));

      _this2.update = false;

      if (!context.store) {
        throw new Error("You must mount EFX-connected components with a Provider");
      }
      _this2.store = context.store;
      _this2.state = mapStateToProps(_this2.store.state);
      _this2.subscriptionId = _this2.store.subscribe(function (state) {
        _this2.setState(mapStateToProps(state));
      });
      return _this2;
    }

    _createClass(_class, [{
      key: "componentWillReceiveProps",
      value: function componentWillReceiveProps() {
        this.update = true;
      }
    }, {
      key: "shouldComponentUpdate",
      value: function shouldComponentUpdate(nextProps, nextState) {
        if (this.update) {
          this.update = false;
          return true;
        }
        var _iteratorNormalCompletion2 = true;
        var _didIteratorError2 = false;
        var _iteratorError2 = undefined;

        try {
          for (var _iterator2 = Object.keys(nextState)[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
            var key = _step2.value;

            if (nextState[key] !== this.state[key]) {
              return true;
            }
          }
        } catch (err) {
          _didIteratorError2 = true;
          _iteratorError2 = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion2 && _iterator2.return) {
              _iterator2.return();
            }
          } finally {
            if (_didIteratorError2) {
              throw _iteratorError2;
            }
          }
        }

        return false;
      }
    }, {
      key: "componentWillUnmount",
      value: function componentWillUnmount() {
        this.store.unsubscribe(this.subscriptionId);
      }
    }, {
      key: "render",
      value: function render() {
        return React.createElement(component, _extends({
          dispatch: this.store.dispatch
        }, defaultProps, this.state, this.props));
      }
    }]);

    return _class;
  }(React.Component), _class.contextTypes = {
    store: PropTypes.object
  }, _temp;
}

var Provider = exports.Provider = function (_React$Component2) {
  _inherits(Provider, _React$Component2);

  function Provider() {
    _classCallCheck(this, Provider);

    return _possibleConstructorReturn(this, (Provider.__proto__ || Object.getPrototypeOf(Provider)).apply(this, arguments));
  }

  _createClass(Provider, [{
    key: "getChildContext",
    value: function getChildContext() {
      return {
        store: this.props.store
      };
    }
  }, {
    key: "render",
    value: function render() {
      return this.props.children;
    }
  }]);

  return Provider;
}(React.Component);

Provider.childContextTypes = {
  store: PropTypes.object
};
function makeAction(rawAction) {
  var _this4 = this;

  if (!process.env.NODE_ENV === "test") {
    return rawAction;
  }

  var toHaveBeenCalledResolver = void 0;
  var toHaveBeenCalledPromise = new Promise(function (resolve) {
    toHaveBeenCalledResolver = resolve;
  });

  var action = function action(arg) {
    return function (store) {
      var returnValue = rawAction(arg)(store);
      toHaveBeenCalledResolver();

      if (returnValue instanceof Promise) {
        // We reassign the method to return the promise result of the last invocation.
        action.toFinish = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
          return regeneratorRuntime.wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  _context.prev = 0;
                  _context.next = 3;
                  return returnValue;

                case 3:
                  _context.next = 7;
                  break;

                case 5:
                  _context.prev = 5;
                  _context.t0 = _context["catch"](0);

                case 7:
                case "end":
                  return _context.stop();
              }
            }
          }, _callee, _this4, [[0, 5]]);
        }));
      }
      return returnValue;
    };
  };

  action.toFinish = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2() {
    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _context2.next = 2;
            return toHaveBeenCalledPromise;

          case 2:
            _context2.next = 4;
            return action.toFinish();

          case 4:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2, _this4);
  }));

  return action;
}